<?php
/**
 * @package	Speedup Optimization
 * @copyright	Copyright (C) 2022 SiteGuarding.com. All rights reserved.
 * @GNU General Public License
 */

defined( '_JEXEC' ) or die;

ini_set("display_errors", "Off");


if (version_compare(JVERSION, '3.0', '<'))
{
	if (JFactory::getApplication()->get('jquery') !== true)
	{
		// Load jQuery in no conflict mode with B/C support
		JHtml::script('../media/com_speedup/jquery.min.js');
		JHtml::script('../media/com_speedup/jquery-migrate.min.js');
		JHtml::script('../media/com_speedup/jquery-noconflict.js');
		JFactory::getApplication()->set('jquery', true);
	}
}
else
{
JHtml::_('jquery.framework'); // load jquery
JHtml::_('jquery.ui');
}

$document = JFactory::getDocument();
$document->addStyleSheet('../media/com_speedup/semantic.min.css');
$document->addScript('../media/com_speedup/semantic.min.js');
$document->addScript('../media/com_speedup/javascript.js');

include_once('functions.php');

if (isset($_GET['option']) && $_GET['option'] == 'com_speedup')
{
    if (isset($_POST['action']) && $_POST['action'] == 'speedup01_purge_all') {
	    speedup01_ajax_purge_all();
	    die;
    }
    if (isset($_POST['action']) && $_POST['action'] == 'speedup01_enabled') {
	    speedup01_ajax_enabled();
	    die;
    }

}


JToolBarHelper::title( JText::_( 'Speedup Optimization' ));


        $on_file = JPATH_ROOT.'/webanalyze/firewall/firewall.speedup.on';
        if (!file_exists($on_file)) 
		{
            $is_speedup_enabled = false;
        }
        else 
		{
            $is_speedup_enabled = true;
        }
		

        
        if ($is_speedup_enabled)
        {
            $menu_txt = '<span class="green ui label">Disable Optimization (Current status: enabled)</span>';
        }
        else {
            $menu_txt = '<span class="red ui label">Enable Optimization (Current status: disabled)</span>';
        }
		
	    $action = '';
        if (isset($_REQUEST['action'])) $action = trim($_REQUEST['action']);
        
        // Actions
        if ($action != '')
        {
            $action_message = '';
            switch ($action)
            {
					
                case 'Save_Settings':

					$data = array();
					$action_type = 'ok';
					$data['com_speedup_status'] = intval($_POST['com_speedup_status']);
					$action_message = 'Settings saved';
					com_speedup_Set_Params($data);
					if ($data['com_speedup_status']) {
						$license = com_speedup_get_licence_info();
						if ($license === true) {
							//com_speedup_PatchJMIndex_file(true);
						} else {
							$action_message = $license;
							$action_type = 'alert';
						}
						
					} else {
						//com_speedup_PatchJMIndex_file(false);
					}

                    break;
            }
            

        }
		


	    ?>


	        <style>
        .subhead-collapse.collapse {
            height: 0px;
            visibility: hidden;
        }
        img.help{max-width:600px}
        </style>
        <div class="wrap" style="text-align: center">
        <h1>SpeedUp Optimization (Help & Installation)</h1>
        
        <h3>Increasing website performance and reducing load time.</h3>
        <p>At least 10x improvement in overall site performance. Reduced page load time: increased visitor time on site. Improves web server performance.</p>
        
        <p>To activate SpeedUp Optimization for WordPress website please complete the following steps. It will take no more than 30 - 60 seconds.</p>
        
        <?php
        // Add core files if it's necessary 
        speedup01_Install_core_files();
        
        // Check if all files are installed
        if (speedup01_Is_SpeedUp_module_Installed())
        {
            ?>
            <h2 style="color:#13bf14">All necessary files are already installed</h2>
            <h3>Want to See Real-time Results?</h3>
            <?php
            $on_file = JPATH_ROOT.'/webanalyze/firewall/firewall.speedup.on';
            if (!file_exists($on_file)) 
            {
                $button_html = "<button id=\"speedup-enable\" class=\"positive ui button\">Enable Optimization</button>";
            }
            else {
                $button_html = "<button id=\"speedup-enable\" class=\"negative ui button\">Disable Optimization</button>";
            }
            
            echo "<p>".$button_html."&nbsp;&nbsp;&nbsp; <button id=\"speedup-purge\" class=\"ui button\" id='wp-admin-bar-speedup-purge-all-2'>Purge Cache</button></p>";
        }
        ?>
        
        <img style="width: 350px;" src="<?php echo '../media/com_speedup/images/img.svg'; ?>"/>
        
        <hr />
        
        <h2>Step 1. Create your account on our platform.</h2>
        <?php
        $link = speedup01_ServiceURL().'/en/signup';
        ?>
        <p>To create the account click this link <a href="<?php echo $link; ?>" target="_blank"><?php echo $link; ?></a></p>
        
        <h2>Step 2. Add your website into panel.</h2>
        <p><b>Click "ADD NEW WEBSITE" button:</b><br /><br /><img class="help" src="<?php echo '../media/com_speedup/images/step1.png'; ?>" /></p>
        <p><b>Enter your website URL:</b><br /><br /><img class="help" src="<?php echo '../media/com_speedup/images/step2.png'; ?>" /></p>
        
        <h2>Step 3. Activate SpeedUp for your website.</h2>
        <p><b>Go to "Performance & Analytics" and click on airplane icon:</b><br /><br /><img class="help" src="<?php echo '../media/com_speedup/images/step3.png'; ?>" /></p>
        <p><b>Activate Website Performance Optimization:</b><br /><br /><img class="help" src="<?php echo '../media/com_speedup/images/step4.png'; ?>" /></p>
        
        <hr />
        
        <p>
        <?php
        $link = speedup01_ServiceURL().'/livechat/index.html';
        ?>
    		<a href="<?php echo $link; ?>" target="_blank">
    			<img src="<?php echo '../media/com_speedup/images/livechat.png'; ?>"/>
    		</a><br>
            <?php
            $link = speedup01_ServiceURL().'/en/contacts';
            ?>
    		For any questions and support please use LiveChat or this <a href="<?php echo $link; ?>" rel="nofollow" target="_blank">contact form</a>.<br>
    		<br>
    		<a href="<?php echo speedup01_ServiceURL(); ?>" target="_blank"><?php echo str_replace("y", "", 'ySyiytyyeGyyuyayrdyinyg.ycyom');; ?></a> - Website Security. Professional security services against hacker activity.<br>
		</p>
        
        </div>


<script>
    var ajaxurl = '<?=$_SERVER['REQUEST_URI'];?>';
    jQuery( "#speedup-purge" ).click(function() {
        jQuery.post(
            ajaxurl,
            {
                'action': 'speedup01_purge_all'
            },
            function(response)
            {
                var json = jQuery.parseJSON( response );
                if (json.hasOwnProperty('msg'))
                {
                    alert(json['msg']);
                }
                if (json.hasOwnProperty('redirect'))
                {
                    if (json['redirect'] != '') window.location.replace(json['redirect']);
                }
                window.location.reload();
            }
        ).fail(function() {
            alert('AJAX Error! Please contact support!');
        });

    });


	<?php
	$on_file = JPATH_ROOT.'/webanalyze/firewall/firewall.speedup.on';
	if (!file_exists($on_file))
	{
		echo "var is_speedup_enabled = 0;"."\n";
	}
	else {
		echo "var is_speedup_enabled = 1;"."\n";
	}
	?>

    jQuery( "#speedup-enable" ).click(function() {


        if (is_speedup_enabled == 1)
        {
            if (confirm("Are you sure you want to disable optimization?"))
            {
                // OK - disable
                jQuery.post(
                    ajaxurl,
                    {
                        'action': 'speedup01_enabled',
                        'status': 'disable'
                    },
                    function(response){
                        is_speedup_enabled = 0;
                        //jQuery('#wp-admin-bar-speedup-toggle-status a.ab-item').text("Enable Optimization (Current status: disabled)");

                        var json = jQuery.parseJSON( response );
                        if (json.hasOwnProperty('msg'))
                        {
                            alert(json['msg']);
                        }
                        if (json.hasOwnProperty('redirect'))
                        {
                            if (json['redirect'] != '') window.location.replace(json['redirect']);
                        }
                        window.location.reload();
                    }
                ).fail(function() {
                    alert('AJAX Error! Please contact support!');
                });
            } else {
                // Cancel
            }
        }
        else {
            // Enable
            jQuery.post(
                ajaxurl,
                {
                    'action': 'speedup01_enabled',
                    'status': 'enable'
                },
                function(response){
                    is_speedup_enabled = 1;
                    //jQuery('#wp-admin-bar-speedup-toggle-status a.ab-item').text("Disable Optimization (Current status: enabled)");

                    var json = jQuery.parseJSON( response );
                    if (json.hasOwnProperty('msg'))
                    {
                        alert(json['msg']);
                    }
                    if (json.hasOwnProperty('redirect'))
                    {
                        if (json['redirect'] != '') window.location.replace(json['redirect']);
                    }
                    window.location.reload();
                }

            ).fail(function() {
                alert('AJAX Error! Please contact support!');
            });
        }

    });

</script>